from html.parser import HTMLParser
from typing import Any

from reportlab.lib.abag import ABag

class _PCT(float):
    _normalizer: float
    _value: Any
    def __new__(cls, v): ...
    def normalizedValue(self, normalizer): ...
    def __copy__(self): ...
    def __deepcopy__(self, mem): ...

class _ExValidate:
    tag: Any
    attr: Any
    def __init__(self, tag, attr) -> None: ...
    def invalid(self, s) -> None: ...
    def validate(self, parser, s): ...
    def __call__(self, parser, s): ...

class _CheckSup(_ExValidate):
    fontSize: Any
    def validate(self, parser, s): ...
    def __call__(self, parser, s): ...

class _CheckUS(_ExValidate):
    def validate(self, parser, s): ...

class ParaFrag(ABag): ...

class ParaParser(HTMLParser):
    def __getattr__(self, attrName): ...
    def start_b(self, attributes) -> None: ...
    def end_b(self) -> None: ...
    def start_strong(self, attributes) -> None: ...
    def end_strong(self) -> None: ...
    def start_i(self, attributes) -> None: ...
    def end_i(self) -> None: ...
    def start_em(self, attributes) -> None: ...
    def end_em(self) -> None: ...
    def _new_line(self, k) -> None: ...
    def start_u(self, attributes) -> None: ...
    def end_u(self) -> None: ...
    def start_strike(self, attributes) -> None: ...
    def end_strike(self) -> None: ...
    def _handle_link(self, tag, attributes) -> None: ...
    def start_link(self, attributes) -> None: ...
    def end_link(self) -> None: ...
    def start_a(self, attributes) -> None: ...
    def end_a(self) -> None: ...
    def start_img(self, attributes) -> None: ...
    def end_img(self) -> None: ...
    def start_super(self, attributes) -> None: ...
    def end_super(self) -> None: ...
    start_sup: Any
    end_sup: Any
    def start_sub(self, attributes) -> None: ...
    def end_sub(self) -> None: ...
    def start_nobr(self, attrs) -> None: ...
    def end_nobr(self) -> None: ...
    def handle_charref(self, name) -> None: ...
    def syntax_error(self, lineno, message) -> None: ...
    def _syntax_error(self, message) -> None: ...
    def start_greek(self, attr) -> None: ...
    def end_greek(self) -> None: ...
    def start_unichar(self, attr) -> None: ...
    def end_unichar(self) -> None: ...
    def start_font(self, attr) -> None: ...
    def end_font(self) -> None: ...
    def start_span(self, attr) -> None: ...
    def end_span(self) -> None: ...
    def start_br(self, attr) -> None: ...
    def end_br(self) -> None: ...
    _style: Any
    nlinks: int
    _defaultLineWidths: Any
    _defaultLineColors: Any
    _defaultLineOffsets: Any
    _defaultLineGaps: Any
    _defaultLinkUnderline: Any
    def _initial_frag(self, attr, attrMap, bullet: int = ...): ...
    _stack: Any
    def start_para(self, attr) -> None: ...
    def end_para(self) -> None: ...
    bFragList: Any
    def start_bullet(self, attr) -> None: ...
    def end_bullet(self) -> None: ...
    def start_seqdefault(self, attr) -> None: ...
    def end_seqdefault(self) -> None: ...
    def start_seqreset(self, attr) -> None: ...
    def end_seqreset(self) -> None: ...
    def start_seqchain(self, attr) -> None: ...
    end_seqchain: Any
    def start_seqformat(self, attr) -> None: ...
    end_seqformat: Any
    start_seqDefault: Any
    end_seqDefault: Any
    start_seqReset: Any
    end_seqReset: Any
    start_seqChain: Any
    end_seqChain: Any
    start_seqFormat: Any
    end_seqFormat: Any
    def start_seq(self, attr) -> None: ...
    def end_seq(self) -> None: ...
    def start_ondraw(self, attr) -> None: ...
    start_onDraw: Any
    end_onDraw: Any
    end_ondraw: Any
    def start_index(self, attr) -> None: ...
    end_index: Any
    def start_unknown(self, attr) -> None: ...
    end_unknown: Any
    def _push(self, tag, **attr) -> None: ...
    def _pop(self, tag): ...
    def getAttributes(self, attr, attrMap): ...
    verbose: Any
    caseSensitive: Any
    ignoreUnknownTags: Any
    _crashOnError: Any
    def __init__(
        self,
        verbose: int = ...,
        caseSensitive: int = ...,
        ignoreUnknownTags: int = ...,
        crashOnError: bool = ...,
    ) -> None: ...
    fragList: Any
    def _iReset(self) -> None: ...
    errors: Any
    def _reset(self, style) -> None: ...
    def handle_data(self, data) -> None: ...
    def handle_cdata(self, data) -> None: ...
    _seq: Any
    def _setup_for_parse(self, style) -> None: ...
    def _complete_parse(self): ...
    def _tt_handle(self, tt) -> None: ...
    _tt_handlers: Any
    def _tt_start(self, tt) -> None: ...
    def tt_parse(self, tt, style): ...
    def findSpanStyle(self, style) -> None: ...
    def parse(self, text, style): ...
    def handle_starttag(self, tag, attrs) -> None: ...
    def handle_endtag(self, tag) -> None: ...
    def handle_entityref(self, name) -> None: ...
